package com.shkj.wms.service;

import com.shkj.common.core.domain.Result;
import com.shkj.wms.domain.SysBatch;
import com.shkj.wms.vo.SysBatchVo;
import com.shkj.wms.bo.SysBatchQueryBo;
import com.shkj.wms.bo.SysBatchAddBo;
import com.shkj.wms.bo.SysBatchEditBo;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;

/**
 * 批次Service接口
 *
 * @author lch
 * @date 2022-04-09
 */
public interface ISysBatchService extends IService<SysBatch> {
	/**
	 * 查询单个
	 *
     * @param id
     * @return
     */
	Result<SysBatchVo> queryById(Long id);

	/**
     * 查询列表
     *
     * @param bo
     * @return
     */
	List<SysBatchVo> queryList(SysBatchQueryBo bo);

	/**
	 * 根据新增业务对象插入批次
	 * @param bo 批次新增业务对象
	 * @return
	 */
	Result<Boolean> insertByAddBo(SysBatchAddBo bo);

	/**
	 * 根据编辑业务对象修改批次
	 * @param bo 批次编辑业务对象
	 * @return
	 */
	Result<Boolean> updateByEditBo(SysBatchEditBo bo);

	/**
	 * 校验并删除数据
	 * @param ids 主键集合
	 * @param isValid 是否校验,true-删除前校验,false-不校验
	 * @return
	 */
	Result<Boolean> deleteWithValidById(List<Long> ids, Boolean isValid);

	/**
	 * 获取批次信息 如果存在返回id 如果不存在先保存然后返回id
	 */
	Result<SysBatch> getSysBatch(SysBatchAddBo bo);
}
